// SPDX-FileCopyrightText: 2017-2022 Carl Zeiss Microscopy GmbH
//
// SPDX-License-Identifier: LGPL-3.0-or-later

#include "testImage.h"

/*static*/ const void* CTestImage::GetZStd1CompressedImageWithHiLoPacking(size_t* size, int* width, int* height)
{
    static const unsigned char rawData[70] = {
        0x03, 0x01, 0x01, 0x28, 0xB5, 0x2F, 0xFD, 0x60, 0x00, 0x07, 0xCD, 0x01,
        0x00, 0x70, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF,
        0xFF, 0xFF, 0x00, 0x00, 0x11, 0x00, 0xF7, 0x73, 0x05, 0x80, 0x21, 0xB0,
        0xE2, 0x82, 0x04, 0x00, 0x83, 0x0B, 0x12, 0x00, 0x0C, 0x2E, 0x48, 0x00,
        0x30, 0xB8, 0x20, 0x01, 0xC0, 0xE0, 0x42, 0x82, 0x80, 0x85, 0x81, 0x0C,
        0x29, 0xD5, 0x3F, 0x24, 0x80, 0x15, 0xD4, 0xA5, 0x85, 0x0B
    };
    if (size != nullptr)
    {
        *size = sizeof(rawData);
    }

    if (width != nullptr)
    {
        *width = 32;
    }

    if (height != nullptr)
    {
        *height = 32;
    }

    return rawData;
}
